Public Member Functions | Data Fields

# ScanProgressWindow Struct Reference

Window for showing the progress of NewGRF scanning. More...

Inheritance diagram for ScanProgressWindow:

## Public Member Functions
| ScanProgressWindow ()
| Create the window.
| ~ScanProgressWindow ()
| Free the last name buffer.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
void | UpdateNewGRFScanStatus (uint num, const char *name)
| Update the NewGRF scan status.
## Data Fields
char * | last_name
| The name of the last 'seen' NewGRF.
int | scanned
| The number of NewGRFs that we have seen.

## Detailed Description

Window for showing the progress of NewGRF scanning.

Definition at line 1959 of file newgrf_gui.cpp.

## Constructor & Destructor Documentation

ScanProgressWindow::ScanProgressWindow | ( |  | ) | `[inline]`

Create the window.

Definition at line 1964 of file newgrf_gui.cpp.

References _scan_progress_desc, and Window::InitNested().

ScanProgressWindow::~ScanProgressWindow | ( |  | ) | `[inline]`

Free the last name buffer.

Definition at line 1970 of file newgrf_gui.cpp.

References free(), and last_name.

## Member Function Documentation

virtual void ScanProgressWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1998 of file newgrf_gui.cpp.

References _settings_client, DrawFrameRect(), DrawString(), FONT_HEIGHT_NORMAL, FR_BORDERONLY, ClientSettings::gui, GUISettings::last_newgrf_count, max(), SA_HOR_CENTER, scanned, SetDParam(), WD_PAR_VSEP_NORMAL, WID_SP_PROGRESS_BAR, and WID_SP_PROGRESS_TEXT.

void ScanProgressWindow::UpdateNewGRFScanStatus | ( | uint | num,
|  | const char * | name |
| ) |  |  | `[inline]`

Update the NewGRF scan status.

Parameters:

  | num | The number of NewGRFs scanned so far.
  | name | The name of the last scanned NewGRF.

Definition at line 2026 of file newgrf_gui.cpp.

References _settings_client, free(), ClientSettings::gui, last_name, GUISettings::last_newgrf_count, lastof, scanned, and Window::SetDirty().

Referenced by UpdateNewGRFScanStatus().

virtual void ScanProgressWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 1975 of file newgrf_gui.cpp.

References FONT_HEIGHT_NORMAL, GetStringBoundingBox(), max(), SetDParamMaxDigits(), SetDParamMaxValue(), WID_SP_PROGRESS_BAR, WID_SP_PROGRESS_TEXT, and Window::width.

The documentation for this struct was generated from the following file:

- src/newgrf_gui.cpp